package fib;
import static fib.Fibonacci.fib;
import static fib.Fibonacci.fibIter;
import static org.junit.jupiter.api.Assertions.assertAll;
import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertThrows;
import static org.junit.jupiter.api.Assertions.assertTimeout;
import static org.junit.jupiter.api.Assertions.assertTimeoutPreemptively;

import java.time.Duration;
import java.time.temporal.ChronoUnit;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.CsvSource;


class FibonacciTest {
//
//	@Test
//	void nontest() {
//		out.println("abc");
//		var parseInt = parseInt("123");
//		format("%d %d", 1, 2);
//		
//		fail("Not yet implemented");
//	}

	@Disabled
	@Test
	void fibTest1() {
//		assertEquals(3, Fibonacci.fib(3));
		assertEquals(13, fib(3));
		assertEquals(13, fib(3), "aaaaaaaaaaaaaaaa");
		assertEquals(13, fib(3), () -> "aaaaaaaaaaaaaaaa");
//		assertEquals(3, fib.Fibonacci.fib(3));
	}

	void fibTestRossz() {
		assertEquals(13, fib(3));
		assertEquals(14, fib(4));
		assertEquals(15, fib(5));
		assertEquals(16, fib(6));
	}
	
	@Test
	void fibTest2() {
		assertAll(
			() -> assertEquals(13, fib(3)),
			() -> assertEquals(14, fib(4)),
			() -> assertEquals(15, fib(5)),
			() -> assertEquals(16, fib(6))
		);
	}
	
	@Test
	void fibTestIter() {
		assertAll(
				() -> assertEquals(3, fibIter(3)),
				() -> assertEquals(5, fibIter(4)),
				() -> assertEquals(8, fibIter(5)),
				() -> assertEquals(13, fibIter(6))
				);
	}
	
	@ParameterizedTest(name="fib({1}) = {0}")
//	@CsvSource("13, 3")
	@CsvSource({"13, 3", "14, 4"})
	void fibTest3(int result, int n) {
		assertEquals(result, fib(n));
	}
	
	@ParameterizedTest(name="fibIter({1}) = {0}")
	@CsvSource({
		"3, 3",
		"5, 4",
		"8, 5",
		"13, 6"
	})
	void fibTestIter(int result, int n) {
		assertEquals(result, fibIter(n));
	}

	@Test
	void fibTestNeg() {
		assertThrows(
			IllegalArgumentException.class,
			() -> fibIter(-3)
		);
	}
		
	@Test
	void fibTimeout() {
		assertTimeout(Duration.of(5, ChronoUnit.SECONDS),
			() -> fib(2000)
		);
	}
	
}
