import java.util.function.BiFunction;
import java.util.function.Consumer;
import java.util.function.Function;
import java.util.function.IntBinaryOperator;
import java.util.function.IntConsumer;
import java.util.function.IntSupplier;
import java.util.function.Predicate;
import java.util.function.Supplier;

public class Lambdas {
	public static void main2(String[] args) {
		Supplier<String> supp = () -> "baz";
		Supplier<Integer> supp2 = () -> 654;
		Consumer<Integer> cons = n -> System.out.println(123 * n);
		Consumer<String> sysoCons = System.out::println;
		Function<Integer, String> fun = n -> "abc" + n;
		BiFunction<Boolean, Integer, String> fun2 =
			(b, n) -> "abc" + (b ? n : 2 * n);
		IntConsumer consInt = n -> System.out.println(123 * n);
		IntSupplier suppInt = () -> 4;
		IntBinaryOperator funInt = (n, m) -> 2 * n + m;

			
		System.out.println(supp.get());
		cons.accept(10);
		consInt.accept(10);
		cons.andThen(System.out::println).accept(20);
		sysoCons.accept("abcd");
		System.out.println(fun.apply(123));
		System.out.println(fun2.apply(true, 123));
		System.out.println(fun2.apply(false, 123));
		System.out.println(suppInt.getAsInt());
		System.out.println(funInt.applyAsInt(5, 123));
	}

	public static void main3(String[] args) {
		MyInterface3 fooCreator =
			() -> "foo";
		MyInterface3 foobarCreator =
			new MyInterface3() {
				boolean b = true;
			
				@Override
				public String create() {
					b = !b;
					return b ? "foo" : "bar";
				}
		};

//		Local variable isFoo defined
//		in an enclosing scope must be
//		final or effectively final
//		final boolean[] isFoo = { false };
		boolean[] isFoo = { false };
				
		MyInterface3 foobarCreator2 =
			() -> { isFoo[0] = !isFoo[0]; return isFoo[0] ? "foo" : "bar"; };

		System.out.println(fooCreator.create());
		System.out.println(fooCreator.create());
		System.out.println(fooCreator.create());

		System.out.println(foobarCreator.create());
		System.out.println(foobarCreator.create());
		System.out.println(foobarCreator.create());
		System.out.println(foobarCreator.create());
		System.out.println(foobarCreator.create());
		System.out.println(foobarCreator.create());
		System.out.println(foobarCreator.create());

		System.out.println(foobarCreator2.create());
		System.out.println(foobarCreator2.create());
		System.out.println(foobarCreator2.create());
		System.out.println(foobarCreator2.create());
		System.out.println(foobarCreator2.create());
		System.out.println(foobarCreator2.create());

		var valami = 1;
		switch (valami) {
		case 1: System.out.println("1!"); break;
		case 2: System.out.println("2!"); break;
		case 3: System.out.println("3!"); break;
		default: System.out.println("default!"); break;
		}
	}

	public static void main(String[] args) {
		Runnable r = () -> System.out.println("Hello");
		// lambda; nvtelen fggvny
		MyRunnable r2 = () -> System.out.println("Hello");
		// nvtelen osztly
		MyRunnable r3 = new MyRunnable() {
			@Override
			public void run() {
				System.out.println("Hello");
			}
		};

		
		MyInterface2 duplaKiir =
			s -> System.out.println(s + s);
		duplaKiir =
			s -> System.out.println(s + " * 2 = " + s + s);
		duplaKiir =
			(String s) -> System.out.println(s + " * 2 = " + s + s);
		duplaKiir =
			(var s) -> System.out.println(s + " * 2 = " + s + s);
		duplaKiir =
			(var s) -> {
				System.out.println(s + " * 2 = " + s + s);
				System.out.println("(msodik utasts)");
			};
//		duplaKiir =
//			new MyInterface2() {
//				@Override
//				public void run(String s) {
//					System.out.println(s + " * 2 = " + s + s);
//				}
//			};
		duplaKiir =
			s -> System.out.println(s);
		duplaKiir =
			System.err::println;
		duplaKiir =
			s -> Lambdas.myPrintout(s);
		duplaKiir =
			s -> Lambdas.myPrintout(s);
		duplaKiir =
			Lambdas::myPrintout;
		
		System.out.println(r.getClass().getName());
		System.out.println(r2.getClass().getName());
		System.out.println(r3.getClass().getName());
		
//		printout();
		r.run();
		r2.run();
		r3.run();
		duplaKiir.run("abc");
		duplaKiir.run("xyz");

		Runnable r4 = () -> System.out.println("abc");
		Runnable r5 = () -> {
			System.out.println("abc");
			System.out.println("xyz");
		};

		Consumer<Integer> cons = n -> {
			System.out.println("abc" + n);
			System.out.println("xyz" + n);
		};
		
		Supplier<Integer> supp;
		
		Function<Integer, String> f = n -> "x" + (2 * n + 1);

		int[] hack = { 0 };
		Function<Integer, Integer> f2 = n -> n + ++hack[0];

		System.out.println(f2.apply(10));
		System.out.println(f2.apply(10));
		System.out.println(f2.apply(10));
		System.out.println(f2.apply(10));
		System.out.println(f2.apply(10));

		BiFunction<Integer, String, String> f3 =
			(num, str) -> str + num + str;

		System.out.println(f3.apply(10, "xyz"));
		System.out.println(f3.apply(10, "xyz"));

		Predicate<Integer> pred = i -> i % 2 == 0;

		Function<String, Integer> f4 = s -> {
			if ("".equals(s))
				try {
					throw new Exception();
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			return s.length();
		};
		
		MyFunction<String, Integer> f4v2 = s -> {
			if ("".equals(s))   throw new Exception();
			return s.length();
		};

		Function<String, Integer> f4noExc = noExc(f4v2);
	
		MyLambda5 lambda5 = Lambdas::f;
	}

	private static Function<String, Integer> noExc(MyFunction<String, Integer> f4v2) {
		return n -> {
			try {
				return f4v2.apply(n);
			} catch (Exception e) {
				return null;
			}
		};
	}

	static void myPrintout(String s) {
		System.out.println(s);
	}

	static int f(int a, int b, int c, int d) {
		return a + b + c + d;
	}

}

@FunctionalInterface
interface MyRunnable {
	void run();
}

@FunctionalInterface
interface MyInterface2 {
	void run(String s);
}

@FunctionalInterface
interface MyInterface3 {
	String create();
}

@FunctionalInterface
interface MyFunction<T, T2> {
	T2 apply(T t) throws Exception;
}

@FunctionalInterface
interface MyLambda5 {
	int apply(int a, int b, int c, int d);
}
