import static org.junit.jupiter.api.Assertions.assertAll;
import static org.junit.jupiter.api.Assertions.assertEquals;

import java.util.Scanner;
import java.util.function.BiConsumer;
import java.util.function.IntConsumer;
import java.util.function.IntSupplier;
import java.util.function.IntUnaryOperator;
import java.util.stream.IntStream;

import org.junit.jupiter.api.Test;

class LambdaSolutions {
//	Készíts olyan lambdát, amely többször meghívva a pozitív egész számokat adja ki.
//	static Supplier<Integer> positiveNums;
	static IntSupplier positiveNums = new IntSupplier() {
		int currentNum = 0;
		@Override
		public int getAsInt() {
			return ++currentNum;
		}
	};
	
//	Készíts faktoriális lambdát.
//	Készíts Fibonacci lambdát.
//	static Function<Integer, Integer> fact1 = n -> {
//	static IntFunction<Integer> fact1 = n -> {
	static IntUnaryOperator fact1 = n -> {
		int result = 1;
		for (int i = 1; i <= n; i++) {
			result *= i;
		}
		return result;
	};
	
	static IntUnaryOperator fact3 = new IntUnaryOperator() {
		@Override
		public int applyAsInt(int n) {
			return n == 1 ? 1 : n * applyAsInt(n-1);
		}
	};
	
	static IntUnaryOperator fact2 =
		n -> n == 1 ? 1 : n * LambdaSolutions.fact2.applyAsInt(n-1);
	
	
	@Test
	void test() {
		assertAll(
			() -> {
				assertEquals(1, positiveNums.getAsInt());
				assertEquals(2, positiveNums.getAsInt());
				assertEquals(3, positiveNums.getAsInt());
			}
//			,
//			() -> {
//				assertEquals(1, positiveNums.getAsInt());
//				assertEquals(2, positiveNums.getAsInt());
//				assertEquals(3, positiveNums.getAsInt());
//			}
			, () -> assertEquals(120, fact1.applyAsInt(5))
		);
	}
	

	public static void main(String[] args) {
		// Készíts olyan lambdát, amely többször kiírja a beérkező számokat.
		IntConsumer printer = new IntConsumer() {
			Scanner sc = new Scanner(System.in);
			
			@Override
			public void accept(int n) {
				var line = sc.nextLine();
				IntStream.rangeClosed(1, n)
					.forEach(i -> System.out.println(line));
			}
		};

//		printer.accept(3);
//		printer.accept(5);

		BiConsumer<Integer, String> printer2 = (n, txt) -> {
			IntStream.rangeClosed(1, n)
			.forEach(i -> System.out.println(txt));
		};

		printer2.accept(3, "abc");
	}
	
}
